* configure.ac: Require libksba 0.9.11.
[gnupg.git] / TODO
1                                                               -*- outline -*-
2
3 * IMPORTANT
4 Check that openpty and pty.h are available and build symcryptrun only
5 then.  Run shred on the temporary files.
6
7
8 * src/base64
9 ** Make parsing more robust
10 Currently we don't cope with overlong lines in the best way.
11
12 * sm/call-agent.c
13 ** The protocol uses an incomplete S-expression
14 We should always use valid S-Exp and not just parts.
15 ** Some code should go into import.c
16 ** When we allow concurrent service request in gpgsm, we
17 might want to have an agent context for each service request
18 (i.e. Assuan context).
19
20 * sm/certreqgen.c
21 ** Improve error reporting
22 ** Do some basic checks on the supplied DNs
23
24 * sm/certchain.c
25 ** When a certificate chain was sucessfully verified, make ephemeral certs used  in this chain permanent.
26 ** figure out how to auto retrieve a key by serialno+issuer.
27    Dirmngr is currently not able to parse more than the CN.
28
29 * sm/certlist.c
30 ** ocspSigning usage is not fully implemented
31    We should review the entire CRL and OCSP validation system.
32    Okay.  This has been fixed in dirmngr when running it in system
33    daemon mode.
34
35 * sm/decrypt.c
36 ** replace leading zero in integer hack by a cleaner solution
37
38 * sm/gpgsm.c
39 ** Support --output for all commands
40 ** mark all unimplemented commands and options.
41 ** Print a hint when MD2 is the cause for a problem.
42 ** Implement --default-key
43 ** Using --export-secret-key-p12 with a non-pth agent
44    This leads to a lockup because gpgsm is still accessing the agent
45    while gpg-protect-tool wants to pop up the pinentry.  Solution is
46    to release the connection.  This is not trivial, thus we are going
47    to do that while changing gpgsm to allow concurrent operations.
48 ** support the anyPolicy semantic
49 ** Check that we are really following the verification procedures in rfc3280.
50
51 * sm/keydb.c
52 ** Check file permissions
53 ** Check that all error code mapping is done.
54 ** Remove the inter-module dependencies between gpgsm and keybox
55 ** Add an source_of_key field
56
57 * agent/gpg-agent.c
58 ** A SIGHUP should also restart the scdaemon
59    But do this only after all connections terminated.  As of now we
60    only send a RESET.
61 ** Watch the child process if not invoked as a daemon
62    and terminate after the child has terminated
63
64 * agent/command.c
65 ** Make sure that secure memory is used where appropriate
66
67 * agent/pkdecrypt.c, agent/pksign.c
68 ** Don't use stdio to return results.
69 ** Support DSA
70
71 * agent/divert-scd.c
72  Remove the agent_reset_scd kludge.
73
74 * Move pkcs-1 encoding into libgcrypt.
75
76 * Use a MAC to protect sensitive files.
77   The problem here is that we need yet another key and it is unlikely
78   that users are willing to remember that key too.  It is possible to
79   do this with a smartcard, though.
80
81 * sm/export.c
82 ** Return an error code or a status info per user ID.
83
84 * tests
85 ** Makefile.am
86   We use printf(1) to setup the library path, this is not portable.
87   Furthermore LD_LIBRARY_PATH is not used on all systems.  It doesn't
88   matter for now, because we use some GNU/*BSDish features anyway.
89
90 ** Add a test to check the extkeyusage.
91
92 * doc/
93 ** Explain how to setup a root CA key as trusted
94 ** Explain how trustlist.txt might be managed.
95 ** Write a script to generate man pages from texi.
96
97 * Requirements by the BSI
98 ** Support authorityKeyIdentifier.keyIdentifier
99    This needs support in libksba/src/cert.c as well as in sm/*.c.
100    Need test certs as well.  Same goes for CRL authorityKeyIdentifier.
101
102
103 * Windows port
104 ** gpgsm's LISTKEYS does not yet work
105     Fix is to change everything to libestream
106 ** Signals are not support 
107     This means we can't reread a configuration
108 ** No card status notifications.
109
110
111 * [scdaemon] release the card after use so that gpg 1.4 is abale to access it
112